# gamemath
#
# Gino Wuytjens

import math
import pygame
import base.sprites.sprite

EPS = 0.0000001


def distance_points(x0, y0):
    #x = math.fabs(x0)
    #y = math.fabs(y0)
    return math.fabs(x0 - y0)


def distance((x0, y0), (x1, y1)):
    return math.sqrt(((x1 - x0) ** 2) + ((y1 - y0) ** 2))


def angle((x0, y0), (x1, y1)):
    #denominator = x1 - x0 if x0 < x1 else x0 - x1
    # if denominator == 0.0:
    #   denominator += EPS
    # negate the angle, because pygame (as most computer gfx packages do) has origin at topleft corner of the screen
    return math.atan2((y1 - y0), (x0 - x1)) + math.pi


def rotate(image, angle):
    orig_rect = image.get_rect()
    rot_image = pygame.transform.rotate(image, angle)
    rot_rect = orig_rect.copy()
    rot_rect.center = rot_image.get_rect().center
    rot_image = rot_image.subsurface(rot_rect).copy()
    return rot_image


def distanceSprite(mobject0, mobject1):
    return distance(mobject0.getPos(), mobject1.getPos())


def angleSprite(mobject0, mobject1):
    return angle(mobject0.getPos(), mobject1.getPos())


def tracePoint(x1, y1, x2, y2, l):
    theta = math.atan2((y2 - y1), (x2 - x1))
    if theta < 0:
        d = 180 * (theta + math.pi * 2) / math.pi
    else:
        d = 180 * theta / math.pi
    dx = math.cos(math.radians(d))
    dy = math.sin(math.radians(d))

    return x2 + dx * l, y2 + dy * l
